import os

# a: 323i
# b: 325i
# c: 330i
# d: 328i

if __name__ == '__main__':
    a_files = [f.path for f in os.scandir('input/a') if f.is_file()]
    b_files = [f.path for f in os.scandir('input/b') if f.is_file()]
    c_files = [f.path for f in os.scandir('input/c') if f.is_file()]
    d_files = [f.path for f in os.scandir('input/d') if f.is_file()]
    a_data = [open(f, 'rb').read() for f in a_files]
    b_data = [open(f, 'rb').read() for f in b_files]
    c_data = [open(f, 'rb').read() for f in c_files]
    d_data = [open(f, 'rb').read() for f in d_files]

    print(a_files, b_files, c_files, d_files)

    first_l = len(a_data[0])
    for d in [*a_data, *b_data, *c_data, *d_data]:
        if len(d) != first_l:
            raise ValueError(f"File length {len(d)} mismatches original file length of {first_l}")

    for addr in range(first_l):
        a_first = a_data[0][addr]
        b_first = b_data[0][addr]
        c_first = c_data[0][addr]
        d_first = d_data[0][addr]

        if addr not in []:
            inconsistent = False
            # find bytes identical in a_data, identical in b_data, but different between the two
            for aa in a_data[1:]:
                if aa[addr] != a_first:
                    inconsistent = True
                    break  # not common amongst a
            for bb in b_data[1:]:
                if bb[addr] != b_first:
                    inconsistent = True
                    break  # not common amongst b
            for cc in c_data[1:]:
                if cc[addr] != c_first:
                    inconsistent = True
                    break  # not common amongst c
            for dd in d_data[1:]:
                if dd[addr] != d_first:
                    inconsistent = True
                    break  # not common amongst d

            if inconsistent:
                continue

            if a_first == b_first == c_first == d_first:
                continue

            if not (b_first == c_first):  # 325 == 330
                continue
            if not (a_first < d_first):   # 323 < 328
                continue
            if not (d_first < b_first):   # 328 < 325 (?)
                continue

        print(f"ADDRESS: {hex(addr):>8}    323: {hex(a_first):>4}    325: {hex(b_first):>4}    330: {hex(c_first):>4}    328: {hex(d_first):>4}")
